zipios::ZipCDirEntry Class Reference

Specialization of ZipLocalEntry, that add fields for storing the extra information, that is only present in the entries in the zip central directory and not in the local entry headers. More...

`#include <ziphead.h>`

Inheritance diagram for zipios::ZipCDirEntry:
[legend]

## Public Member Functions

| ZipCDirEntry (const string &_filename="", const string &_file_comment="", const vector< unsigned char > &_extra_field=vector< unsigned char >())
void | setDefaultWriter ()
ZipCDirEntry & | operator= (const class ZipCDirEntry &src)
virtual string | toString () const
| Returns a human-readable string representation of the entry.
virtual string | getComment () const
| Returns the comment of the entry, if it has one.
virtual void | setComment (const string &comment)
| Sets the comment field for the FileEntry.
virtual uint32 | getLocalHeaderOffset () const
virtual void | setLocalHeaderOffset (uint32 offset)
int | getCDirHeaderSize () const
virtual FileEntry * | clone () const
| Create a heap allocated clone of the object this method is called for.
Public Member Functions inherited from zipios::ZipLocalEntry
| ZipLocalEntry (const string &_filename="", const vector< unsigned char > &_extra_field=vector< unsigned char >())
void | setDefaultExtract ()
ZipLocalEntry & | operator= (const class ZipLocalEntry &src)
virtual uint32 | getCompressedSize () const
| Returns the compressed size of the entry.
virtual uint32 | getCrc () const
| Returns the Crc for the entry, if it has one.
virtual vector< unsigned char > | getExtra () const
| Returns a vector of bytes of extra data that may be stored with the entry.
virtual StorageMethod | getMethod () const
| Returns the method used to store the entry in the FileCollection.
virtual string | getName () const
| Returns the full filename of the entry, including a path if the entry is stored in a subfolder.
virtual string | getFileName () const
| Returns the filename of the entry.
virtual uint32 | getSize () const
| Returns the (uncompressed) size of the entry data.
virtual int | getTime () const
| Returns the date and time of FIXME: what?
virtual bool | isValid () const
| Any method or operator that initializes a FileEntry may set a flag, that specifies whether the read entry is valid or not.
virtual bool | isDirectory () const
| Returns true if the entry is a directory.
virtual void | setCompressedSize (uint32 size)
| Set the compressed size field of the entry.
virtual void | setCrc (uint32 crc)
| Sets the crc field.
virtual void | setExtra (const vector< unsigned char > &extra)
| Sets the extra field.
virtual void | setMethod (StorageMethod method)
| Sets the storage method field for the entry.
virtual void | setName (const string &name)
| Sets the name field for the entry.
virtual void | setSize (uint32 size)
| Sets the size field for the entry.
virtual void | setTime (int time)
| Sets the time field for the entry.
int | getLocalHeaderSize () const
bool | trailingDataDescriptor () const
Public Member Functions inherited from zipios::FileEntry
virtual | ~FileEntry ()
| FileEntry destructor.

## Friends

istream & | operator>> (istream &is, ZipCDirEntry &zcdh)
ostream & | operator<< (ostream &os, const ZipCDirEntry &zcdh)
bool | operator== (const ZipLocalEntry &zlh, const ZipCDirEntry &ze)

## Additional Inherited Members

Protected Member Functions inherited from zipios::FileEntry
void | ref () const
unsigned int | unref () const
Protected Attributes inherited from zipios::ZipLocalEntry
uint16 | extract_version
uint16 | gp_bitfield
uint16 | compress_method
uint16 | last_mod_ftime
uint16 | last_mod_fdate
uint32 | crc_32
uint32 | compress_size
uint32 | uncompress_size
uint16 | filename_len
uint16 | extra_field_len
string | filename
vector< unsigned char > | extra_field
bool | _valid
Protected Attributes inherited from zipios::FileEntry
ReferenceCount< FileEntry > | _refcount
Static Protected Attributes inherited from zipios::ZipLocalEntry
static const uint32 | signature = 0x04034b50

## Detailed Description

Specialization of ZipLocalEntry, that add fields for storing the extra information, that is only present in the entries in the zip central directory and not in the local entry headers.

Definition at line 102 of file ziphead.h.

## Constructor & Destructor Documentation

## ZipCDirEntry()

zipios::ZipCDirEntry::ZipCDirEntry | ( | const string & | _filename = "",
|  | const string & | _file_comment = "",
|  | const vector< unsigned char > & | _extra_field = vector< unsigned char >() )

inline

Definition at line 108 of file ziphead.h.

## ~ZipCDirEntry()

virtual zipios::ZipCDirEntry::~ZipCDirEntry | ( |  | ) |

inline virtual

Definition at line 140 of file ziphead.h.

## Member Function Documentation

## clone()

FileEntry * zipios::ZipCDirEntry::clone | ( |  | ) | const

virtual

Create a heap allocated clone of the object this method is called for.

The caller is responsible for deallocating the clone when he is done with it.

Returns
  A heap allocated copy of the object this method is called for.

Reimplemented from zipios::ZipLocalEntry.

Definition at line 231 of file ziphead.cpp.

## getCDirHeaderSize()

int zipios::ZipCDirEntry::getCDirHeaderSize | ( |  | ) | const

Definition at line 226 of file ziphead.cpp.

## getComment()

string zipios::ZipCDirEntry::getComment | ( |  | ) | const

virtual

Returns the comment of the entry, if it has one.

Otherwise it returns an empty string.

Returns
  the comment associated with the entry, if there is one.

Reimplemented from zipios::ZipLocalEntry.

Definition at line 199 of file ziphead.cpp.

## getLocalHeaderOffset()

uint32 zipios::ZipCDirEntry::getLocalHeaderOffset | ( |  | ) | const

virtual

Definition at line 203 of file ziphead.cpp.

## operator=()

ZipCDirEntry & zipios::ZipCDirEntry::operator= | ( | const class ZipCDirEntry & | src | ) |

inline

Definition at line 214 of file ziphead.h.

## setComment()

void zipios::ZipCDirEntry::setComment | ( | const string & | comment | ) |

virtual

Sets the comment field for the FileEntry.

Parameters

  comment | string with the new comment.

Reimplemented from zipios::ZipLocalEntry.

Definition at line 212 of file ziphead.cpp.

## setDefaultWriter()

void zipios::ZipCDirEntry::setDefaultWriter | ( |  | ) |

Definition at line 189 of file ziphead.cpp.

## setLocalHeaderOffset()

void zipios::ZipCDirEntry::setLocalHeaderOffset | ( | uint32 | offset | ) |

virtual

Definition at line 207 of file ziphead.cpp.

## toString()

string zipios::ZipCDirEntry::toString | ( |  | ) | const

virtual

Returns a human-readable string representation of the entry.

Returns
  a human-readable string representation of the entry.

Reimplemented from zipios::ZipLocalEntry.

Definition at line 218 of file ziphead.cpp.

## Friends And Related Symbol Documentation

## operator==

bool operator== | ( | const ZipLocalEntry & | zlh,
|  | const ZipCDirEntry & | ze )

friend

Definition at line 20 of file ziphead.cpp.

The documentation for this class was generated from the following files:

- ziphead.h
- ziphead.cpp